' Mini-Rasterbike 2: Netzwerk-Client-Version
' Luft via DOSISODE und TCP/IP
' Installationsvoraussetzung: Packet Driver fr die Netzwerkkarte im
' LAN oder DOSPPP05.ZIP bei einer Modemwhlverbindung sowie SOCKETS.EXE
' von DOSISODE geladen (=DOS-TCP/IP-Stack)

' $INCLUDE: 'qb.bi'

DECLARE SUB GibSpielerStatusAus (s%, t%, r%)
DECLARE SUB GibStatusAus (t$, c%)

TYPE Spieler
	x AS INTEGER
	y AS INTEGER
	ListSt AS INTEGER
END TYPE

TYPE Ausschnitt
	xAb AS INTEGER
	yAb AS INTEGER
	xGr AS INTEGER
	yGr AS INTEGER
	focus AS INTEGER
END TYPE

CONST FeldGroesse% = 50
CONST nSpielerMax% = 10
CONST stdPortNr% = 11971   ' Standard-TCP/IP-Portnummer
CONST TelPufGr% = 100

DIM dosIntEin AS RegType, dosIntAus AS RegType

DIM auss(1 TO 5) AS Ausschnitt        ' Ausschnitte
DIM Sp(0 TO nSpielerMax% - 1) AS Spieler ' Spieler
DIM f%(-3 TO FeldGroesse% + 4, -3 TO FeldGroesse% + 4)  ' Rand vorsehen!
DIM SHARED z%(77), fa%(77), eigSpieler% ' darzustelllende Zeichen und Farben
DIM TelPuf$(0 TO TelPufGr% - 1), nTel%, nfTel%

RANDOMIZE TIMER

FOR i% = 0 TO 77
	READ z%(i%), fg%, hg%
	fa%(i%) = 16 * hg% + fg%
NEXT i%

DATA 219, 8, 0, 176, 7, 6, 205, 14, 7, 186, 14, 7
DATA 201, 14, 7, 187, 14, 7, 200, 14, 7, 188, 14, 7
DATA 16, 15, 4, 30, 15, 4, 17, 15, 4, 31, 15, 4, 254, 12, 4, 15, 14, 4, 35, 12, 4
DATA 16, 15, 1, 30, 15, 1, 17, 15, 1, 31, 15, 1, 254, 9, 1, 15, 14, 1, 35, 12, 1
DATA 16, 15, 2, 30, 15, 2, 17, 15, 2, 31, 15, 2, 254, 10, 2, 15, 14, 2, 35, 12, 2
DATA 16, 15, 5, 30, 15, 5, 17, 15, 5, 31, 15, 5, 254, 13, 5, 15, 14, 5, 35, 12, 5
DATA 16, 15, 3, 30, 15, 3, 17, 15, 3, 31, 15, 3, 254, 11, 3, 15, 14, 3, 35, 12, 3
DATA 16, 15, 6, 30, 15, 6, 17, 15, 6, 31, 15, 6, 254, 2, 6, 15, 14, 6, 35, 12, 6
DATA 16, 15, 7, 30, 15, 7, 17, 15, 7, 31, 15, 7, 254, 1, 7, 15, 14, 7, 35, 12, 7
DATA 16, 15, 1, 30, 15, 1, 17, 15, 1, 31, 15, 1, 254, 13, 1, 15, 14, 1, 35, 12, 1
DATA 16, 15, 4, 30, 15, 4, 17, 15, 4, 31, 15, 4, 254, 10, 4, 15, 14, 4, 35, 12, 4
DATA 16, 15, 2, 30, 15, 2, 17, 15, 2, 31, 15, 2, 254, 5, 2, 15, 14, 2, 35, 12, 2

' Feld setzen
FOR y% = -3 TO -1
	FOR x% = -3 TO FeldGroesse% + 4
		f%(x%, y%) = 1
		f%(x%, y% + FeldGroesse% + 5) = 1
	NEXT x%
NEXT y%
FOR y% = 0 TO FeldGroesse% + 1
	FOR x% = -3 TO -1
		f%(x%, y%) = 1
		f%(x% + FeldGroesse% + 5, y%) = 1
	NEXT x%
NEXT y%
f%(0, 0) = 4: f%(FeldGroesse% + 1, 0) = 5
f%(0, FeldGroesse% + 1) = 6: f%(FeldGroesse% + 1, FeldGroesse% + 1) = 7
FOR x% = 1 TO FeldGroesse%
	f%(x%, 0) = 2
	f%(x%, FeldGroesse% + 1) = 2
NEXT x%
FOR y% = 1 TO FeldGroesse%
	f%(0, y%) = 3
	f%(FeldGroesse% + 1, y%) = 3
	FOR x% = 1 TO FeldGroesse%
		f%(x%, y%) = 0
	NEXT x%
NEXT y%

' Alle Spieler zu Beginn inaktiv
FOR i% = 0 TO nSpielerMax% - 1
	Sp(i%).ListSt = -1
NEXT i%

' Scroll-Ausschnitte definieren
' Hauptausschnitt des steuernden Spieler selber
auss(1).xAb = 17
auss(1).yAb = 0
auss(1).xGr = 23
auss(1).yGr = 23
' Nebenansichten der Gegner
FOR y% = 0 TO 1
	FOR x% = 0 TO 1
		i% = 2 + 2 * y% + x%
		auss(i%).xAb = 8 * x%
		auss(i%).yAb = 8 * y%
		auss(i%).xGr = 7
		auss(i%).yGr = 7
	NEXT x%
NEXT y%

' Testen, ob Waterloo TCP mit DOSISODE-Interface geladen wurde
dosIntEin.ax = &HE00  ' SI_CHECKLOAD
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
IF dosIntAus.cx <> &H1234 THEN
	PRINT "Sie mssen noch SOCKETS.EXE zusammen mit dem Packet Driver"
	PRINT "Ihrer Netzwerkkarte laden!"
	END
END IF

DO
	INPUT "IP-Adresse des Rasterbike-Servers (z.B. 192.168.0.2)"; ipAdr$
	SELECT CASE ipAdr$
	CASE "S", "s"
		GOSUB Schliessen
	CASE "R", "r"
		GOSUB Zuruecksetzen
	END SELECT
	ipBin$ = ""
	DO
		p% = INSTR(ipAdr$, ".")
	IF p% = 0 THEN EXIT DO
		ipBin$ = ipBin$ + CHR$(VAL(LEFT$(ipAdr$, p% - 1)))
		ipAdr$ = MID$(ipAdr$, p% + 1)
	LOOP
	ipBin$ = ipBin$ + CHR$(VAL(ipAdr$))
LOOP UNTIL LEN(ipBin$) = 4

PRINT "Portnummer (Standard="; stdPortNr%;
INPUT ")"; sPortNr$
IF sPortNr$ = "" THEN
	portNr% = stdPortNr%
ELSE
	portNr% = VAL(sPortNr$)
END IF

SCREEN 0
WIDTH 40, 25
COLOR 7, 0, 0: CLS
LOCATE 25, 1
COLOR 11
PRINT "Status:";
GibStatusAus "Baue Verbindung auf...", 2

' Initialisieren
dosIntEin.ax = &H300  ' SI_SOCKET
dosIntEin.cx = 1      ' Typ: 1=Stream (TCP), 2=Dgram (UDP)
dosIntEin.dx = 1      ' Socket-ID = 1
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
IF dosIntAus.ax <> 0 THEN
	GibStatusAus "Fehler beim Initialisieren. Code" + STR$(dosIntEin.cx), 12
	dummy$ = INPUT$(1)
	GOSUB Zuruecksetzen
	END
END IF
PufSeg% = dosIntAus.cx
PufOffs% = dosIntAus.dx

GibStatusAus "Kontaktiere Host...", 2
' Socket aufbauen
DEF SEG = PufSeg%
dosIntEin.ax = &H500   ' SI_CONNECT
dosIntEin.dx = 1
rsockaddr$ = RIGHT$(MKI$(portNr%), 1) + LEFT$(MKI$(portNr%), 1) + ipBin$
' Daten bertragen: Nur ab dos_buffer+2 ndern
FOR i% = 1 TO LEN(rsockaddr$)
	POKE PufOffs% + i% + 1, ASC(MID$(rsockaddr$, i%, 1))
NEXT i%
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
IF dosIntAus.ax <> 0 THEN
	GibStatusAus "Fehler" + STR$(dosIntAus.cx) + " beim Verbinden", 12
	dummy$ = INPUT$(1)
	GOSUB Schliessen
	GOSUB Zuruecksetzen
	END
END IF

' Non-Blocking IO aktivieren, damit Tastatur und Netzwerk-Socket
' zusammen abgefragt werden knnen

GibStatusAus "Setze Eigenschaften...", 2
dosIntEin.ax = &HB00  ' SI_IOCTL
dosIntEin.dx = 1      ' Socket-ID
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
InSchluss% = 0

' Initialisierung: Handshake mit Server
GibStatusAus "Sende Begrssungsnachricht...", 2
Tel$ = "Raster"
GOSUB SchreibeTelegramm
' Einladungsphase
GibStatusAus "Warte auf Rckantwort...", 2
nAusschn% = 1
stat% = 0
Master% = 0
timeOut! = TIMER + 40!
WHILE stat% <> 2
	GOSUB LiesTelegramm
	IF Tel$ <> "" THEN
		SELECT CASE stat%
		CASE 0
			' Erwarte "Bike"-Handshake
			IF LEN(Tel$) = 5 AND LEFT$(Tel$, 4) = "Bike" THEN
				eigSpieler% = ASC(RIGHT$(Tel$, 1))
				stat% = 1
				Sp(eigSpieler%).x = 25  ' nur temporr, damit Ausschnitt zeichnen
				Sp(eigSpieler%).y = 25  ' schon mglich ist
				auss(1).focus = eigSpieler%
				GibStatusAus "Einladungsphase - bitte warten", 2
			ELSE
				GibStatusAus "Fehler: Kein Rasterbike-Server", 12
				GOSUB Schliessen
				GOSUB Zuruecksetzen
				dummy$ = INPUT$(1)
				END
			END IF
		CASE 1
			IF Tel$ = "NY" THEN
				GibStatusAus "Noch nicht alle bereit!", 4
			ELSEIF Tel$ = "MA" THEN
				GibStatusAus "Master - Taste=Ende Einladung", 10
				Master% = -1
			ELSEIF Tel$ = "PP" THEN
				stat% = 2
			ELSEIF LEFT$(Tel$, 1) = "P" AND LEN(Tel$) MOD 3 = 1 THEN
				' Positionstelegramm
				Tel$ = MID$(Tel$, 2)
				WHILE Tel$ <> ""
					i% = ASC(MID$(Tel$, 3, 1)) \ 4
					Sp(i%).x = ASC(LEFT$(Tel$, 1))
					Sp(i%).y = ASC(MID$(Tel$, 2, 1))
					Sp(i%).ListSt = ASC(MID$(Tel$, 3, 1)) AND 3
					r% = ASC(MID$(Tel$, 3, 1)) AND 3
					f%(Sp(i%).x, Sp(i%).y) = 8 + 7 * i% + r%
					Tel$ = MID$(Tel$, 4)
					' Ausschnitt zuweisen
					IF i% <> eigSpieler% AND nAusschn% < 5 THEN
						nAusschn% = nAusschn% + 1
						auss(nAusschn%).focus = i%
					END IF
					GibSpielerStatusAus i%, -1, 0
				WEND
				GOSUB SpielerDarstellen
			ELSEIF LEFT$(Tel$, 1) = "X" AND LEN(Tel$) = 3 THEN
				' unerwarteter Verbindungszusammenbruch
				i% = ASC(RIGHT$(Tel$, 1)) \ 4
				f%(Sp(i%).x, Sp(i%).y) = 14 + 7 * i%
				Sp(i%).ListSt = -2
				GibSpielerStatusAus i%, 6, 0
				GOSUB SpielerDarstellen
			ELSE
				GibStatusAus "Falsches Telegramm bei BEREIT", 12
			END IF
		CASE ELSE
			PRINT "Interner Fehler"
			ERROR 51
		END SELECT
	END IF
	t$ = INKEY$
	IF t$ <> "" THEN
		IF stat% = 1 AND Master% THEN
			' Masterspieler gibt Stopp
			Tel$ = "EI"
			GOSUB SchreibeTelegramm
		ELSE
			SOUND 440, 1!
		END IF
	END IF
	IF stat% = 0 AND TIMER > timeOut! THEN
		GibStatusAus "Zeitberlauf - fehlgeschlagen", 12
		GOSUB Schliessen
		GOSUB Zuruecksetzen
		dummy$ = INPUT$(1)
		END
	END IF
WEND
GibStatusAus "Bitte bereitmachen! => Taste", 13
PLAY "o3l16t128ceg>c"
WHILE stat% <> 4
	GOSUB LiesTelegramm
	IF Tel$ <> "" THEN
		IF Tel$ = "A0" AND stat% = 3 THEN
			stat% = 4
		ELSEIF LEN(Tel$) = 1 THEN
			i% = ASC(Tel$) \ 4
			GibSpielerStatusAus i%, 4, 0
		ELSEIF LEN(Tel$) = 3 AND LEFT$(Tel$, 1) = "X" THEN
			' unerwarteter Verbindungszusammenbruch
			i% = ASC(RIGHT$(Tel$, 1)) \ 4
			f%(Sp(i%).x, Sp(i%).y) = 14 + 7 * i%
			GibSpielerStatusAus i%, 6, 0
			Sp(i%).ListSt = -2
			GOSUB SpielerDarstellen
		ELSE
			GibStatusAus "Falsches Telegramm bei PP", 12
		END IF
	END IF
	t$ = INKEY$
	IF t$ <> "" THEN
		IF stat% = 2 THEN
			Tel$ = "R"
			GOSUB SchreibeTelegramm
			stat% = 3
		ELSE
			SOUND 440, 1!
		END IF
	END IF
WEND
' Achtung! Fertig! Los!
GibStatusAus "Achtung!", 4
SOUND 523, 1!

WHILE stat% <> 5
	GOSUB LiesTelegramm
	IF Tel$ <> "" THEN
		SELECT CASE Tel$
		CASE "A1"
			SOUND 523, 1!
			GibStatusAus "Fertig!", 14
		CASE "A2"
			SOUND 1047, 3!
			GibStatusAus "Los!", 2
			stat% = 5
		CASE ELSE
			GibStatusAus "Falsches Telegramm bei SETGO", 12
		END SELECT
	END IF
WEND

LosLoesch! = TIMER + 1!
LoeschFl% = -1
' Ab hier Spiel :-)
FOR i% = 0 TO nSpielerMax% - 1
	IF Sp(i%).ListSt >= 0 THEN
		GibSpielerStatusAus i%, Sp(i%).ListSt, 0
	END IF
NEXT i%
WHILE stat% <> 7
	GOSUB LiesTelegramm
	IF Tel$ <> "" THEN
		IF LEFT$(Tel$, 1) = "P" AND LEN(Tel$) MOD 3 = 1 THEN
			' Positionstelegramm
			Tel$ = MID$(Tel$, 2)
			WHILE Tel$ <> ""
				i% = ASC(MID$(Tel$, 3, 1)) \ 4
				f%(Sp(i%).x, Sp(i%).y) = 12 + 7 * i%
				Sp(i%).x = ASC(LEFT$(Tel$, 1))
				Sp(i%).y = ASC(MID$(Tel$, 2, 1))
				r% = ASC(MID$(Tel$, 3, 1)) AND 3
				f%(Sp(i%).x, Sp(i%).y) = 8 + 7 * i% + r%
				Tel$ = MID$(Tel$, 4)
			WEND
			GOSUB SpielerDarstellen
		ELSEIF LEN(Tel$) = 1 THEN
			i% = ASC(Tel$) \ 4
			f%(Sp(i%).x, Sp(i%).y) = 8 + 7 * i% + (ASC(Tel$) AND 3)
			GibSpielerStatusAus i%, ASC(Tel$) AND 3, 0
			SOUND 120, 1
			GOSUB SpielerDarstellen
		ELSEIF LEFT$(Tel$, 1) = "K" AND LEN(Tel$) = 3 THEN
			' Png! :-(
			FOR j% = 100 TO 60 STEP -10
				SOUND 9 * j%, 1
				SOUND 7 * j%, 1
			NEXT j%
			i% = ASC(RIGHT$(Tel$, 1)) \ 4
			f%(Sp(i%).x, Sp(i%).y) = 13 + 7 * i%
			GibSpielerStatusAus i%, 5, ASC(MID$(Tel$, 2, 1))
			IF i% = eigSpieler% THEN
				GibStatusAus "Leider :-( gestrzt!", 14
				stat% = 6
			END IF
			GOSUB SpielerDarstellen
		ELSEIF LEFT$(Tel$, 1) = "X" AND LEN(Tel$) = 3 THEN
			' unerwarteter Verbindungszusammenbruch
			i% = ASC(RIGHT$(Tel$, 1)) \ 4
			f%(Sp(i%).x, Sp(i%).y) = 14 + 7 * i%
			GibSpielerStatusAus i%, 6, ASC(MID$(Tel$, 2, 1))
			GOSUB SpielerDarstellen
		ELSEIF LEFT$(Tel$, 2) = "Ra" THEN
			RangLst$ = Tel$
			stat% = 7
		ELSE
			GibStatusAus "Falsches Telegramm bei INSPIEL", 12
		END IF
	END IF
	t$ = INKEY$
	IF t$ <> "" THEN
		IF stat% = 5 THEN
			SELECT CASE t$
			CASE CHR$(0) + "M"
				Tel$ = "@"
				GOSUB SchreibeTelegramm
			CASE CHR$(0) + "H"
				Tel$ = "A"
				GOSUB SchreibeTelegramm
			CASE CHR$(0) + "K"
				Tel$ = "B"
				GOSUB SchreibeTelegramm
			CASE CHR$(0) + "P"
				Tel$ = "C"
				GOSUB SchreibeTelegramm
			CASE ELSE
				SOUND 440, 1!
			END SELECT
		ELSE
			SOUND 440, 1!
		END IF
	END IF
	IF LoeschFl% AND stat% = 5 AND TIMER > LosLoesch! THEN
		GibStatusAus "Im Spiel", 8
		LoeschFl% = 0
	END IF
WEND

' Rangliste anzeigen
COLOR 7, 0
CLS
PRINT "Rangliste"
PRINT "---------"
FOR i% = 3 TO LEN(Tel$)
	s% = ASC(MID$(Tel$, i%, 1))
	IF s% = eigSpieler% THEN
		COLOR 31, 0
	ELSE
		COLOR 6, 0
	END IF
	PRINT USING "##. "; i% - 2;
	IF s% = eigSpieler% THEN
		COLOR 15, fa%(12 + 7 * s%) \ 16
	ELSE
		COLOR fa%(12 + 7 * s%) AND 15, 0
	END IF
	PRINT USING "Spieler##"; s% + 1
NEXT i%

' Verbindung trennen
Tel$ = "CA"
GOSUB SchreibeTelegramm
InSchluss% = 1   ' Serverseitig den close() ausfhren lassen
WHILE InSchluss% = 1
	GOSUB LiesTelegramm
WEND
GOSUB Schliessen
GOSUB Zuruecksetzen
COLOR 13, 0
PRINT
PRINT "Ende mit Taste"
t$ = INPUT$(1)
WIDTH 80, 25
END

SpielerDarstellen:
DEF SEG = &HB800
FOR i% = 1 TO nAusschn%
	xGr1% = auss(i%).xGr
	yGr1% = auss(i%).yGr
	xAb1% = auss(i%).xAb
	yAb1% = auss(i%).yAb
	xOff% = Sp(auss(i%).focus).x - xGr1% \ 2
	IF xOff% < -3 THEN
		xOff% = -3
	END IF
	IF xOff% > FeldGroesse% + 5 - xGr1% THEN
		xOff% = FeldGroesse% + 5 - xGr1%
	END IF
	yOff% = Sp(auss(i%).focus).y - yGr1% \ 2
	IF yOff% < -3 THEN
		yOff% = -3
	END IF
	IF yOff% > FeldGroesse% + 5 - yGr1% THEN
		yOff% = FeldGroesse% + 5 - yGr1%
	END IF
	FOR y% = yOff% TO yOff% + yGr1% - 1
		h% = 80 * (yAb1% + y% - yOff%) + 2 * xAb1%
		FOR x% = xOff% TO xOff% + xGr1% - 1
			POKE h%, z%(f%(x%, y%))
			POKE h% + 1, fa%(f%(x%, y%))
			h% = h% + 2
		NEXT x%
	NEXT y%
NEXT i%
RETURN

LiesTelegramm:
' Leseversuch ausfhren im Sinne von INKEY$, d.h. nicht blockieren
dosIntEin.ax = &H800  ' SI_RECVFROM
dosIntEin.cx = 200    ' Anzahl Zeichen: Mglichst viele aufs Mal!
dosIntEin.dx = 1      ' Socket-ID
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
IF dosIntAus.ax = -1 THEN
	IF dosIntAus.cx = 35 THEN
		' WOULDBLOCK ignorieren (warten!)
	ELSEIF dosIntAus.cx = 6 THEN
		' EBADF als vom Partner ausgelstes close() behandeln
		IF InSchluss% = 0 THEN
			GibStatusAus "Verbindung unerwartet getrennt", 12
			dummy$ = INPUT$(1)
			GOSUB Schliessen
			GOSUB Zuruecksetzen
			END
		ELSE
			InSchluss% = 2
		END IF
	ELSE
		PRINT "Fehler beim Lesen. Code" + STR$(dosIntAus.cx)
		dummy$ = INPUT$(1)
		GOSUB Schliessen
		GOSUB Zuruecksetzen
		END
	END IF
ELSE
	DEF SEG = PufSeg%
	FOR i% = 0 TO dosIntAus.ax - 1
		z% = PEEK(PufOffs% + 16 + i%)
		IF z% < 128 THEN
			TelPuf$(nfTel%) = TelPuf$(nfTel%) + CHR$(z%)
		ELSE
			TelPuf$(nfTel%) = TelPuf$(nfTel%) + CHR$(z% AND 127)
			nfTel% = (nfTel% + 1) MOD TelPufGr%
			IF nfTel% = nTel% THEN
				GibStatusAus "Warnung: Pufferberlauf!", 12
			END IF
			TelPuf$(nfTel%) = ""
		END IF
	NEXT i%
END IF
IF nfTel% = nTel% THEN
	Tel$ = ""
ELSE
	Tel$ = TelPuf$(nTel%)
	nTel% = (nTel% + 1) MOD TelPufGr%
END IF
RETURN

SchreibeTelegramm:
DEF SEG = PufSeg%
WHILE Tel$ <> ""
	dosIntEin.ax = &H900     ' SI_SENDTO
	dosIntEin.cx = LEN(Tel$) ' Anzahl Zeichen
	dosIntEin.dx = 1         ' Socket-ID
	FOR i% = 0 TO LEN(Tel$) - 2
		POKE PufOffs% + 16 + i%, ASC(MID$(Tel$, i% + 1, 1))
	NEXT i%
	POKE PufOffs% + 15 + LEN(Tel$), ASC(MID$(Tel$, i% + 1, 1)) OR 128
	CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
	IF dosIntAus.ax < 0 THEN
		PRINT "Fehler beim Schreiben. Code" + STR$(dosIntAus.cx)
		dummy$ = INPUT$(1)
		GOSUB Schliessen
		GOSUB Zuruecksetzen
		END
	END IF
	Tel$ = MID$(Tel$, dosIntAus.ax + 1)
WEND
RETURN

Schliessen:
' Zum Schluss Socket schliessen
dosIntEin.ax = &HC00  ' SI_CLOSE
dosIntEin.dx = 1      ' Socket-ID
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
IF dosIntAus.ax <> 0 THEN
	GibStatusAus "Fehler beim Schliessen. Code" + STR$(dosIntAus.cx), 12
	dummy$ = INPUT$(1)
	GOSUB Zuruecksetzen
	END
END IF
RETURN

Zuruecksetzen:
' Netzwerk-Anwendung ganz beenden
dosIntEin.ax = &HD00  ' SI_SHUTDOWN
CALL INTERRUPT(&H17, dosIntEin, dosIntAus)
RETURN

SUB GibSpielerStatusAus (s%, t%, r%)
	IF s% < 8 THEN
		IF t% = -1 THEN
			LOCATE 16 + s%, 1
			IF s% = eigSpieler% THEN
				COLOR 15, fa%(12 + 7 * s%) \ 16
			ELSE
				COLOR fa%(12 + 7 * s%) AND 15, 0
			END IF
			PRINT USING "Spieler##"; s% + 1;
		ELSEIF t% = 4 THEN
			LOCATE 16 + s%, 11
			COLOR fa%(12 + 7 * s%) AND 15, 0
			PRINT "B";
		ELSE
			DEF SEG = &HB800
			b% = 80 * (15 + s%) + 20
			POKE b%, z%(8 + t% + 7 * s%)
			POKE b% + 1, fa%(8 + t% + 7 * s%)
			IF r% > 0 THEN
				LOCATE 16 + s%, 12
				COLOR 14, 0
				PRINT USING "##"; r%;
			END IF
		END IF
	END IF
END SUB

SUB GibStatusAus (t$, c%)
	LOCATE 25, 9
	COLOR c%, 0
	PRINT t$; SPACE$(31 - LEN(t$));
END SUB

